/* or_check.c: check and normalise or names */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_check.c,v 5.0 90/09/20 16:07:57 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_check.c,v 5.0 90/09/20 16:07:57 pp Exp Locker: pp $
 *
 * $Log:	or_check.c,v $
 * Revision 5.0  90/09/20  16:07:57  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "util.h"
#include "or.h"
#include "table.h"

extern char     *or_tbl;
static Table    *tb_or;
char            or_error[BUFSIZ];


/* ---------------------  Begin  Routines  -------------------------------- */



/* --- *** ---
or_check (or, buf, buf_type, locname)  where:
	or              -       what is being checked
	buf             -       what is returned
	buf_type        -       Channel or local
	lsubdom		-	local proferred table
	replace		-	if synonym'd place to put replacement or
--- *** --- */

#define	MAX_NUM_REPLACES	25

int or_check (or, buf, buf_type, lsubdom, replace)
OR_ptr          *or;
char            *buf;
int             *buf_type;
char		**lsubdom;
char		**replace;
{
	OR_ptr          tptr,
			sptr,
			current_ptr;
	char            current_val[LINESIZE],
			tbuf[LINESIZE],
			tracebuf[LINESIZE],
			*oargv[10];
	int             oargc;
	char		first_lookup[BUFSIZ];
	int		postReplace = FALSE,
			num_replaces = 0,
			aliased = FALSE;

	PP_DBG (("Lib/or_chk()"));

	first_lookup[0] ='\0';
	if (replace != (char **) NULL)
		*replace = NULLCP;

	*lsubdom = NULLCP;
	if ((tptr = loc_ortree) == NULLOR) {
		PP_LOG (LLOG_EXCEPTIONS, ("Lib/or_chk: loc_ortree missing"));
		return NOTOK;
	}

	if ((current_ptr = *or ) == NULLOR) {
		(void) sprintf (or_error, "No OR specified for checking");
		PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
		return NOTOK;
	}


	if (tb_or == NULLTBL) {
		if ((tb_or = tb_nm2struct (or_tbl)) == NULLTBL) {
			(void) sprintf(or_error, "No or table!!!");
			PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
			return NOTOK;
		}
	}

	or_or2std (*or, tracebuf, FALSE);
	PP_TRACE (("Lib/or_chk's tracebuf: '%s'", tracebuf));

	buf[0] = '\0';

	for (;;) {
		or_or2dmn (NULLOR, current_ptr, current_val);
		PP_DBG (("Lib/or_chk: Checking part: '%s'", current_val));


		if (tb_k2val (tb_or, current_val, tbuf) != OK) {
			if (buf[0] == '\0' && postReplace == FALSE) {
				char	*oargv[10], tmp[BUFSIZ];
				char    *dollar;

				PP_DBG (("Lib/or_chk: Check failed '%s' '%s'",
				     current_val, tracebuf));
				if (first_lookup[0] != '\0')
					or_or2std(or_lastpart(*or), tmp, FALSE);
				else
					tmp[0] = '\0';

				if (sstr2arg (current_val, 9, oargv, ".")) {
					if (dollar = index (oargv[0], '$')) 
						*dollar = ' ';
					if (first_lookup[0] == '\0'
					    || lexequ(first_lookup, tmp) == 0) 
						(void) sprintf (or_error, 
							 "Unknown '%s' in '%s')",
							 oargv[0], tracebuf);
					else
						(void) sprintf (or_error, 
							 "Unknown '%s' in '%s' (aka '%s')",
							 oargv[0], tmp, first_lookup);
				}
				else {
					if (first_lookup[0] == '\0'
					    || lexequ(first_lookup, tmp) == 0)
						(void) sprintf (or_error,
							 "Unknown '%s' in '%s'",
							 current_val, tracebuf);
					else
						(void) sprintf(or_error,
							"Unknown '%s' in '%s' (aka '%s')",
							current_val, tmp, first_lookup);
				}
				return NOTOK;
			}
			else if (buf[0] == '\0' && postReplace == TRUE) {
				/* no direct match with replacement */
				/* rewind checking and start again */
				current_ptr = *or;
				postReplace = FALSE;
				continue;
			}
			else {
				return OK;
			}
		}

		postReplace = FALSE;

		PP_DBG (("Lib/or_chk: Hit: '%s'", tbuf));

		/* --- Have found a pointer --- */
		oargc = sstr2arg (tbuf, 9, oargv, " \t\n,");

		if (lexequ (oargv[0], "valid") == 0) {
			buf[0] = '\0';
			current_ptr = current_ptr -> or_next;
			continue;
		}


		if (lexequ (oargv[0], "local") == 0) {
			/* --- This is local - map rest to buf --- */
			if (current_ptr -> or_next == NULLOR) {
				(void) sprintf (or_error,
		"local entry found - but no more components '%s'",
					 tracebuf);
				PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
				return NOTOK;
			}

			tptr = current_ptr;
			current_ptr = current_ptr -> or_next;
			current_ptr ->  or_prev = NULLOR;

			if (current_ptr -> or_type <= OR_OU
			    || (or_getpn (current_ptr, buf) == FALSE))
				or_or2std (current_ptr, buf, TRUE);
				
			current_ptr -> or_prev = tptr;
			*buf_type = OR_ISLOCAL;

			PP_TRACE (("Lib/or_chk: Returning local: '%s' '%s' ",
				buf, tracebuf));
			if (oargc > 1)
				*lsubdom = strdup (oargv[1]);
/*			return OK;*/
			continue;
		}  /* --- end of if local --- */


		if (oargc < 2) {
			(void) sprintf (or_error,
				"Format error in OR table '%s' '%s'",
				current_val, tracebuf);
			PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
			return NOTOK;
		}


		if (lexequ (oargv[0], "mta") == 0) {
			(void) strcpy (buf, oargv[1]);
			*buf_type = OR_ISMTA;
			current_ptr = current_ptr -> or_next;
			continue;
		}


		if (lexequ (oargv[0], "realalias") == 0) {
			/* --- invalidate previous hits --- */
			buf[0] = '\0';
			postReplace = TRUE;
			aliased = TRUE;
			if (++num_replaces > MAX_NUM_REPLACES) {
				(void) sprintf(or_error, "Too many aliases/synonyms when resolving '%s'",
					tracebuf);
				PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
				return NOTOK;
			}

			if ((tptr = or_dmn2or (oargv[1])) == NULLOR) {
				(void) sprintf(or_error, "Invalid syntax alias '%s' '%s'",
					oargv[1], tracebuf);
				PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
				return NOTOK;
			}
			
			if (first_lookup[0] == '\0')
				or_or2std(or_lastpart(*or), first_lookup, FALSE);

			/* --- free off old head --- */
			if ((sptr = current_ptr -> or_next) != NULLOR) {
				sptr -> or_prev         = NULLOR;
				current_ptr -> or_next  = NULLOR;
			} 
			or_free (*or);

			/* --- add in the new stuff --- */
			*or                     = tptr;
			current_ptr             = or_lastpart (tptr);

			if (sptr != NULLOR) {
				/* --- add back in the rest of old stuff */
				if (sptr -> or_type < current_ptr -> or_type) {
					(void) sprintf (or_error,
						 "Alias out of order '%s' '%s'",
						 oargv[1], tracebuf);
					PP_LOG (LLOG_EXCEPTIONS, 
						("%s", or_error));
					return NOTOK;
				}

				current_ptr -> or_next  = sptr;
				sptr -> or_prev         = current_ptr;
			}
			continue;
		}  /* --- end of if alias --- */

		if (lexequ (oargv[0], "synonym") == 0
		    || lexequ (oargv[0], "alias") == 0) {
			/* --- invalidate previous hits --- */
			buf[0] = '\0';
			postReplace = TRUE;

			if (++num_replaces > MAX_NUM_REPLACES) {
				(void) sprintf(or_error, "Too many aliases/synonyms when resolving '%s'",
					tracebuf);
				PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
				return NOTOK;
			}

			if ((tptr = or_dmn2or (oargv[1])) == NULLOR) {
				(void) sprintf(or_error,
					"Invalid syntax alias '%s' '%s'",
					oargv[1], tracebuf);
				PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
				return NOTOK;
			}
			
			if (first_lookup[0] == '\0')
				or_or2std(or_lastpart(*or), first_lookup, FALSE);

			/* --- free off old head --- */
			if ((sptr = current_ptr -> or_next) != NULLOR) {
				sptr -> or_prev         = NULLOR;
				current_ptr -> or_next  = NULLOR;
			} 
			or_free (*or);

			/* --- add in the new stuff --- */
			*or                     = tptr;
			current_ptr             = or_lastpart (tptr);

			if (sptr != NULLOR) {
				/* --- add back in the rest of old stuff */
				if (sptr -> or_type < current_ptr -> or_type) {
					(void) sprintf (or_error,
						 "Alias out of order '%s' '%s'",
						 oargv[1], tracebuf);
					PP_LOG (LLOG_EXCEPTIONS,
						("%s", or_error));
					return NOTOK;
				}

				current_ptr -> or_next  = sptr;
				sptr -> or_prev         = current_ptr;
			}
			if (aliased == FALSE
			    && replace != (char **) NULL) {
				char	tmp[BUFSIZ];
				if (*replace != NULLCP)
					free(*replace);
				or_or2std(or_lastpart(*or), tmp, FALSE);
				*replace = strdup(tmp);
			}
			continue;
		}  /* --- end of if synonym --- */

		(void) sprintf (or_error, "Unknown alias type '%s' '%s'",
			 oargv[1], tracebuf);
		PP_LOG (LLOG_EXCEPTIONS, ("%s", or_error));
		return NOTOK;

	}  /* end of for */
}
